;GET INFORMATION FOR BOX
(defun inbox ()
     (setq l (getdist "\nENTER LENGTH OF BOX "))
     (setq w (getdist "\nENTER WIDTH OF BOX "))
     (setq h (getdist "\nENTER HEIGHT OF BOX "))
     (setq wt (getdist "\nENTER WALL THICKNESS "))
     (setq tst (getdist "\nENTER TOP SLAB THICKNESS "))
     (setq bst (getdist "\nENTER BOTTOM SLAB THICKNESS "))
     (setq fe (getdist "\nENTER FOOTING EXTENSION "))
     (setq swtofd (getdist "\nENTER SIDE WALL OUTSIDE FACE DOWEL LENGTH "))
     (setq swtifd (getdist "\nENTER SIDE WALL INSIDE FACE DOWEL LENGTH "))
     (setq twtofd (getdist "\nENTER TOP AND BOTTOM WALL OUTSIDE FACE DOWEL LENGTH "))
     (setq twtifd (getdist "\nENTER TOP AND BOTTOM WALL INSIDE FACE DOWEL LENGTH "))
     (setq ol (+ l (* 2 wt)))
     (setq ow (+ w (* 2 wt)))
     (setq oh (+ h tst))
     (setq el (getdist "\nWHAT IS THE TOP OF THE BOTTOM SLAB ELEVATION?"))
)

;DRAW PLANS
(defun plans ()
     (setq spoy (+ 10 bst oh))
     ;SETUP COORDINATES OF OUTSIDE OF BOX
     (setq s 10)
     (setq spx1 (+ s ol))
     (setq spy1 (+ spoy 10))
     (setq spy2 (+ spy1 ow))
     (setq sp1 (list s spy1))
     (setq sp2 (list spx1 spy1))
     (setq sp3 (list spx1 spy2))
     (setq sp4 (list s spy2))
     ;DRAW OUTSIDE OF BOX
     (command "layer" "s" "g3" \r)
     (command "line" sp1 sp2 sp3 sp4 sp1 "")
     ;SET UP COORDONATES FOR DIMENSIONING
     (setq odvloc (list (- s 9) spy1))
     (setq odhloc (list spx1 (+ spy2 9)))
     (setq odw (rtos (* 12 ow) 4 1))
     (setq odl (rtos (* 12 ol) 4 1))
     ;DRAW OUTSIDE DIMENSIONS
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp1 sp4 odvloc odw "exit" 
              "dim" "horiz" sp4 sp3 odhloc odl "exit")
     ;COPY ROOF PLAN
     (setq rpx (+ spx1 10))
     (setq rpy (+ spy2 11))
     (setq zpx (+ rpx ol 10))	
     (setq mw1 (list 0 spoy))
     (setq mw2 (list rpx rpy))
     (setq c2 (list rpx spoy))
     (setq z2 (list zpx rpy))
     (command "zoom" "w" "0,0" z2
              "copy" "w" mw1 mw2 "" mw1 c2)
     ;SETUP COORDINATESOF INSIDE WALL FOR SECTIONAL PLAN
     (setq spx2 (+ s wt))
     (setq spx3 (+ spx2 l))
     (setq spy3 (+ spy1 wt))
     (setq spy4 (+ spy3 w))
     (setq sp5 (list spx2 spy3))
     (setq sp6 (list spx3 spy3))
     (setq sp7 (list spx3 spy4))
     (setq sp8 (list spx2 spy4))
     ;DRAW INSIDE OF WALL
     (command "layer" "s" "g3" \r
              "line" sp5 sp6 sp7 sp8 sp5 "")
     ;SETUP COORDINATES FOR FOOTING EXTENSION
     (setq spx4 (- s fe))
     (setq spx5 (+ spx1 fe))
     (setq spy5 (- spy1 fe))
     (setq spy6 (+ spy2 fe))
     (setq sp9 (list spx4 spy5))
     (setq sp10 (list spx5 spy5))
     (setq sp11 (list spx5 spy6))
     (setq sp12 (list spx4 spy6))
     ;DRAW FOOTING EXTENSION
     (command "layer" "s" "soo" \r
              "line" sp9 sp10 sp11 sp12 sp9 "")
     ;SETUP COORDINATES FOR WALL DIMMENSIONING
     (setq idvloc (list (- s 8) spy1))
     (setq idhloc (list s (+ spy2 8)))
     (setq idwt (rtos (* 12.0 wt) 4 1))
     (setq idw (rtos (* 12.0 w) 4 1))
     (setq idfe (rtos (* 12.0 fe) 4 1))
     (setq idl (rtos (* 12.0 l) 4 1))
     ;DRAW INSIDE DIMENSIONS
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp1 sp5 idvloc idwt "cont" sp8 idw "cont"  sp4 idwt "cont" sp12 idfe "exit"
              "dim" "horiz" sp4 sp8 idhloc idwt "cont"  sp7 idl "cont" sp3 idwt "cont" sp11 idfe "exit")
     ;SETUP COORDINATES FOR INSIDE WALL FOR ROOF PLAN
     (setq rpx1 (+ rpx 10 wt))
     (setq rpx2 (+ rpx1 l))
     (setq rp1 (list rpx1 spy3))
     (setq rp2 (list rpx2 spy3))
     (setq rp3 (list rpx2 spy4))
     (setq rp4 (list rpx1 spy4))
     ;DRAW INSIDE OF WALL FOR ROOF PLAN
     (command "layer" "s" "soh" \r
              "line" rp1 rp2 rp3 rp4 rp1 "") 
)
;DRAW SECTOIN 1 THROUGH SIDE WALLS
(defun sec1 ()
     ;SETUP COORDINATES FOR OUTSIDE CONCRETE
     (setq s1x1 (- s fe))
     (setq s1x2 (+ s1x1 (* 2 fe) ol))
     (setq s1x3 (- s1x2 fe))
     (setq s1x4 (+ s1x1 fe))
     (setq s1x5 (+ s1x4 wt))
     (setq s1x6 (+ s1x5 l))
     (setq sy1 5)
     (setq sy2 (+ sy1 bst))
     (setq sy3 (+ sy2 oh))
     (setq sy4 (- sy3 tst))
     (setq s11 (list s1x1 sy1))   ;outside concrete
     (setq s12 (list s1x2 sy1))
     (setq s13 (list s1x2 sy2))
     (setq s14 (list s1x3 sy2))
     (setq s15 (list s1x3 sy3))
     (setq s16 (list s1x4 sy3))
     (setq s17 (list s1x4 sy2))
     (setq s18 (list s1x1 sy2))
     (setq s19 (list s1x5 sy2))  ;inside concrete
     (setq s120 (list s1x6 sy2))
     (setq s121 (list s1x6 sy4))
     (setq s122 (list s1x5 sy4))
     ;SETUP COORDINATES OF WALL REINF
     (setq s1rx1 (- s1x5 0.16))   ;if dowel start
     (setq s1rx2 (+ s1x4 0.16))   ;of dowel start
     (setq s1rx3 (- s1rx1 0.08))   ;if wall steel start 
     (setq s1rx4 (+ s1rx2 0.08))   ;of wall steel start 
     (setq s1ry1 (+ sy1 bst swtifd))  ;if dowel start
     (setq s1ry2 (+ sy1 bst swtofd))  ;of dowel start
     (setq s1ry3 (+ sy1 0.42))     ;if vert dowel end
     (setq s1ry4 (+ sy1 0.33))     ;of vert dowel end
     (setq s1ry5 (+ s1ry1 0.16))   ;if end of bend around dowel for wall steel
     (setq s1ry6 (+ s1ry2 0.16))   ;of end of bend around   "
     (setq s1ry7 (- sy3 0.42))     ;end of if wall steel
     (setq s1ry8 (- sy3 0.33))     ;end of of wall steel
     (setq s1r1 (list s1rx1 s1ry1))   ;if dowel
     (setq s1r2 (list s1rx1 s1ry3))    
     (setq s1r3 (list s1rx2 s1ry2))   ;of dowel
     (setq s1r4 (list s1rx2 s1ry4))
     (setq s1r5 (list s1rx3 sy2))   ;if wall reinf
     (setq s1r6 (list s1rx3 s1ry1))
     (setq s1r7 (list s1rx1 s1ry5))
     (setq s1r8 (list s1rx1 s1ry7))
     (setq s1r9 (list s1rx4 sy2))    ;of wall reinf
     (setq s1r10 (list s1rx4 s1ry2))
     (setq s1r11 (list s1rx2 s1ry6))
     (setq s1r12 (list s1rx2 s1ry8))
     ;DRAW WALL REINF
     (command "layer" "s" "s1" \r
              "line" s1r1 s1r2 "@1<180" ""
              "line" s1r3 s1r4 "@1<0" ""
              "line" s1r5 s1r6 s1r7 s1r8 ""
              "line" s1r9 s1r10 s1r11 s1r12 "@1<0" "")
     ;MIRROR WALL REINF TO OTHER SIDE
     (setq s1x (+ s1x5 (/ l 2)))
     (setq smw2 (list s1x spoy))
     (setq smp1 (list s1x 0))
     (setq smp2 (list s1x 1))
     ;INSERT KEYS
     (command "insert" "/acad/strblk/wskey" s17 wt 1 0
              "insert" "/acad/strblk/key" s122 wt 1 180  
              "mirror" "w" '(0 0) smw2 "" smp1 smp2 "")
     ;DRAW CONCRETE
     (command "layer" "s" "g3" \r
              "line" s11 s12 s13 s14 s15 s16 s17 s18 s11 ""
              "line" s19 s120 s121 s122 s19 "")
     ;SETUP DIMENSION LINE LOCATIONS
     (setq wodloc (list (- s 9) sy1))
     (setq wofdloc (- s 2))
     (setq wifdloc (+ s1x5 2))
     (setq ofds (list wofdloc sy2))
     (setq ifds (list wifdloc sy2))  
     (setq ods1 (rtos (* 12 bst) 4 1))
     (setq ods2 (rtos (* 12 h) 4 1))
     (setq ods3 (rtos (* 12 tst) 4 1))
     (setq ods4 (rtos (* 12 swtofd) 4 1))
     (setq ods5 (rtos (* 12 swtifd) 4 1))
     :DRAW DIMENSION
     (COMMAND "LAYER" "S" "sooo" \r
              "dim" "vert" s11 s18 wodloc ods1 "cont" s122 ods2 "cont" s16 ods3 "exit"
              "dim" "vert" ofds s1r3 ofds ods4 "exit"
              "dim" "vert" ifds s1r1 ifds ods5 "exit")
     ;DRAW TOP AND BOTTOM SLAB REINF
     (setq s1rx5 (+ s1x1 0.16))    ;bottom rein
     (setq s1rx6 (- s1x2 0.16))    
     (setq s1rx7 (+ s1x4 0.16))    ;top reinf
     (setq s1rx8 (- s1x3 0.16))
     (setq s1ry9 (+ sy1 0.25))   ;bottom reinf
     (setq s1ry10 (- sy2 0.16))
     (setq s1ry11 (+ sy4 0.16))  ;top reinf
     (setq s1ry12 (- sy3 0.16))
     (setq s1r13 (list s1rx5 s1ry9))
     (setq s1r14 (list s1rx6 s1ry9))
     (setq s1r15 (list s1rx5 s1ry10))
     (setq s1r16 (list s1rx6 s1ry10))
     (setq s1r17 (list s1rx7 s1ry11))
     (setq s1r18 (list s1rx8 s1ry11))
     (setq s1r19 (list s1rx7 s1ry12))
     (setq s1r20 (list s1rx8 s1ry12))
     (command "layer" "s" "s1" \r
              "line" s1r13 s1r14 ""
              "line" s1r15 s1r16 ""
              "line" s1r17 s1r18 ""
              "line" s1r19 s1r20 "")

;DRAW SECTION 2 THROUGH TOP AND BOTTOM WALLS
     ;SETUP COORDINATES FOR OUTSIDE CONCRETE
     (setq s2x1 (- rpx1 wt fe))
     (setq s2x2 (+ s2x1 (* 2 fe) ow))
     (setq s2x3 (- s2x2 fe))
     (setq s2x4 (+ s2x1 fe))
     (setq s2x5 (+ s2x4 wt))
     (setq s2x6 (+ s2x5 w))
     (setq s21 (list s2x1 sy1))   ;outside concrete
     (setq s22 (list s2x2 sy1))
     (setq s23 (list s2x2 sy2))
     (setq s24 (list s2x3 sy2))
     (setq s25 (list s2x3 sy3))
     (setq s26 (list s2x4 sy3))
     (setq s27 (list s2x4 sy2))
     (setq s28 (list s2x1 sy2))
     (setq s29 (list s2x5 sy2))  ;inside concrete
     (setq s220 (list s2x6 sy2))
     (setq s221 (list s2x6 sy4))
     (setq s222 (list s2x5 sy4))
     ;SETUP COORDINATES OF WALL REINF
     (setq s2rx1 (- s2x5 0.16))   ;if dowel start
     (setq s2rx2 (+ s2x4 0.16))   ;of dowel start
     (setq s2rx3 (- s2rx1 0.08))   ;if wall steel start 
     (setq s2rx4 (+ s2rx2 0.08))   ;of wall steel start 
     (setq s2ry1 (+ sy1 bst twtifd))  ;if dowel start
     (setq s2ry2 (+ sy1 bst twtofd))  ;of dowel start
     (setq s2ry3 (+ sy1 0.42))     ;if vert dowel end
     (setq s2ry4 (+ sy1 0.33))     ;of vert dowel end
     (setq s2ry5 (+ s2ry1 0.16))   ;if end of bend around dowel for wall steel
     (setq s2ry6 (+ s2ry2 0.16))   ;of end of bend around   "
     (setq s2ry7 (- sy3 0.42))     ;end of if wall steel
     (setq s2ry8 (- sy3 0.33))     ;end of of wall steel
     (setq s2r1 (list s2rx1 s2ry1))   ;if dowel
     (setq s2r2 (list s2rx1 s2ry3))    
     (setq s2r3 (list s2rx2 s2ry2))   ;of dowel
     (setq s2r4 (list s2rx2 s2ry4))
     (setq s2r5 (list s2rx3 sy2))   ;if wall reinf
     (setq s2r6 (list s2rx3 s2ry1))
     (setq s2r7 (list s2rx1 s2ry5))
     (setq s2r8 (list s2rx1 s2ry7))
     (setq s2r9 (list s2rx4 sy2))    ;of wall reinf
     (setq s2r10 (list s2rx4 s2ry2))
     (setq s2r11 (list s2rx2 s2ry6))
     (setq s2r12 (list s2rx2 s2ry8))
     ;DRAW WALL REINF
     (command "layer" "s" "s1" \r
              "line" s2r1 s2r2 "@1<180" ""
              "line" s2r3 s2r4 "@1<0" ""
              "line" s2r5 s2r6 s2r7 s2r8 ""
              "line" s2r9 s2r10 s2r11 s2r12 "@1<0" "")
     ;MIRROR WALL REINF TO OTHER SIDE
     (setq s2x (+ s2x5 (/ w 2)))
     (setq smw2 (list s2x spoy))
     (setq smp1 (list s2x 0))
     (setq smp2 (list s2x 1))
     ;INSERT KEYS
     (command "insert" "/acad/strblk/wskey" s27 wt 1 0
              "insert" "/acad/strblk/key" s222 wt 1 180  
              "mirror" "w" s21 smw2 "" smp1 smp2 "")
     ;DRAW CONCRETE
     (command "layer" "s" "g3" \r
              "line" s21 s22 s23 s24 s25 s26 s27 s28 s21 ""
              "line" s29 s220 s221 s222 s29 "")
     ;SETUP DIMENSION LINE LOCATIONS
     (setq 2wodloc (list (- (+ s2x1 fe) 9) sy1))
     (setq 2wofdloc (- (+ s2x1 fe) 2))
     (setq 2wifdloc (+ s2x5 2))
     (setq 2ofds (list 2wofdloc sy2))
     (setq 2ifds (list 2wifdloc sy2))  
     (setq 2ods4 (rtos (* 12 twtofd) 4 1))
     (setq 2ods5 (rtos (* 12 twtifd) 4 1))
     :DRAW DIMENSION
     (COMMAND "LAYER" "S" "sooo" \r
              "dim" "vert" s21 s28 2wodloc ods2 "cont" s222 ods2 "cont" s26 ods3 "exit"
              "dim" "vert" 2ofds s2r3 2ofds 2ods4 "exit"
              "dim" "vert" 2ifds s2r1 2ifds 2ods5 "exit")
     ;DRAW TOP AND BOTTOM SLAB REINF
     (setq s2rx5 (+ s2x1 0.16))    ;bottom rein
     (setq s2rx6 (- s2x2 0.16))    
     (setq s2rx7 (+ s2x4 0.16))    ;top reinf
     (setq s2rx8 (- s2x3 0.16))
     (setq s2ry9 (+ sy1 0.25))   ;bottom reinf
     (setq s2ry10 (- sy2 0.16))
     (setq s2ry11 (+ sy4 0.16))  ;top reinf
     (setq s2ry12 (- sy3 0.16))
     (setq s2r13 (list s2rx5 s2ry9))
     (setq s2r14 (list s2rx6 s2ry9))
     (setq s2r15 (list s2rx5 s2ry10))
     (setq s2r16 (list s2rx6 s2ry10))
     (setq s2r17 (list s2rx7 s2ry11))
     (setq s2r18 (list s2rx8 s2ry11))
     (setq s2r19 (list s2rx7 s2ry12))
     (setq s2r20 (list s2rx8 s2ry12))
     (command "layer" "s" "s1" \r
              "line" s2r13 s2r14 ""
              "line" s2r15 s2r16 ""
              "line" s2r17 s2r18 ""
              "line" s2r19 s2r20 "")
     ;FIND OUT IF THERE IS A LEFT PIPE
     (setq pleft (getstring "\nIS THERE A PIPE ON THE LEFT SIDE? (Y or N)"))
     (if (= pleft "Y") (progn
     ;GET INFO ON PIPE
     (setq plinv (getdist "\nWHAT IS THE INVERT OF THE LEFT PIPE?"))
     (setq pldiam (getdist "\nWHAT IS THE DIAMETER OF THE LEFT PIPE?"))
     (setq plloc (getdist "\nDISTANCE FROM THE LOWER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq yplpcl (+ plloc spy3))
     (setq plpcl (list spx2 yplpcl))
     (setq yplscl (+ (- plinv el) sy2 (/ pldiam 2)))
     (setq plscl (list s1x5 yplscl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" plpcl 4 pldiam 180
              "insert" "rcp" plscl 4 pldiam 180)
     ;DRAW LOCATIONS OF PIPES
     (setq xpldloc (- s 7))
     (setq pldloc (list xpldloc spy3))
     (setq pld (rtos (* 12 plloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "vert" pldloc plpcl pldloc pld "exit"))
)
    ;FIND OUT IF THERE IS A RIGHT PIPE
     (setq pright (getstring "\nIS THERE A PIPE ON THE RIGHT SIDE? (Y or N)"))
     (if (= pright "Y") (progn
     ;GET INFO ON PIPE
     (setq prinv (getdist "\nWHAT IS THE INVERT OF THE RIGHT PIPE?"))
     (setq prdiam (getdist "\nWHAT IS THE DIAMETER OF THE RIGHT PIPE?"))
     (setq prloc (getdist "\nDISTANCE FROM THE LOWER RIGHT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq yprpcl (+ prloc spy3))
     (setq prpcl (list spx3 yprpcl))
     (setq yprscl (+ (- prinv el) sy2 (/ prdiam 2)))
     (setq prscl (list s1x6 yprscl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" prpcl 4 prdiam 0
              "insert" "rcp" prscl 4 prdiam 0)
     ;DRAW LOCATIONS OF PIPES
     (setq xprdloc (+ spx1 7))
     (setq prdloc (list xprdloc spy3))
     (setq prd (rtos (* 12 prloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp6 prpcl prdloc prd "exit"))
)
    ;FIND OUT IF THERE IS A TOP PIPE
     (setq ptop (getstring "\nIS THERE A PIPE ON THE TOP SIDE? (Y or N)"))
     (if (= ptop "Y") (progn
     ;GET INFO ON PIPE
     (setq ptinv (getdist "\nWHAT IS THE INVERT OF THE TOP PIPE?"))
     (setq ptdiam (getdist "\nWHAT IS THE DIAMETER OF THE TOP PIPE?"))
     (setq ptloc (getdist "\nDISTANCE FROM THE UPPER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq xptpcl (+ ptloc spx2))
     (setq ptpcl (list xptpcl spy4))
     (setq yptscl (+ (- ptinv el) sy2 (/ ptdiam 2)))
     (setq ptscl (list s2x6 yptscl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" ptpcl 4 ptdiam 90
              "insert" "rcp" ptscl 4 ptdiam 0))
)
    ;FIND OUT IF THERE IS A BOTTOM PIPE
     (setq pbot (getstring "\nIS THERE A PIPE ON THE BOTTOM SIDE? (Y or N)"))
     (if (= pbot "Y") (progn
     ;GET INFO ON PIPE
     (setq pbinv (getdist "\nWHAT IS THE INVERT OF THE BOTTOM PIPE?"))
     (setq pbdiam (getdist "\nWHAT IS THE DIAMETER OF THE BOTTOM PIPE?"))
     (setq pbloc (getdist "\nDISTANCE FROM THE LOWER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq xpbpcl (+ pbloc spx2))
     (setq pbpcl (list xpbpcl spy3))
     (setq ypbscl (+ (- pbinv el) sy2 (/ pbdiam 2)))
     (setq pbscl (list s2x5 ypbscl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" pbpcl 4 pbdiam 270
              "insert" "rcp" pbscl 4 pbdiam 180))
)
)


(defun C:BOX ()
     (inbox)
     (plans)
     (sec1)
)
