;--------1---------2---------3---------4---------5---------6---------7
;
;   Advanced AutoLISP Concepts, CADENCE  Feb 1989
;
;   Bill Kramer, Kramer Consulting, Inc.
;   
;
;   Listing 1:  Timer functions.
;
;--------1---------2---------3---------4---------5---------6---------7

(defun t_on ()
  (setq _timer (getvar "date"))
)

(defun t_off ()
  (setq _timer (- (getvar "date") _timer))
  (* _timer 86400.0)
)

(defun C:tester ( / func1 func2 f1list f2list)
  (setq func1 (read (getstring "\nFunction 1 name:"))
        func2 (read (getstring "\nFunction 2 name:"))
        nruns (getint "\nNumber of repetitions:"))
  (repeat nruns
     (t_on)
     (mapcar 'eval (cdr (eval func1))) 
     (setq f1list (cons (t_off) f1list))
     (t_on)
     (mapcar 'eval (cdr (eval func2))) 
     (setq f2list (cons (t_off) f2list))
  )
  (prompt "\n\nAverage Func1: ")
  (princ (setq ave (/ (apply '+ f1list) (length f1list)))) 
  (prompt "  Min: ")(princ (apply 'min f1list))
  (prompt "  Max: ")(princ (apply 'max f1list))
  (prompt "\nAverage Func2: ")
  (princ (setq ave (/ (apply '+ f2list) (length f2list)))) 
  (prompt "  Min: ")(princ (apply 'min f2list))
  (prompt "  Max: ")(princ (apply 'max f2list))
  (princ)
)
;--------1---------2---------3---------4---------5---------6---------7
;
;  Listing 2   Test functions for (SETQ) analysis
;
;--------1---------2---------3---------4---------5---------6---------7
(defun test1 ()
  (setq a 1)
  (setq b 2)
  (setq c 3)
  (setq d 4)
  (setq e 5)
  (setq f 6)
  (setq g 7)
  (setq h 8)
  (setq i 9)
  (setq j 10)
  (setq k 11)
  (setq l 12)
  (setq m 13)
  (setq n 14)
  (setq o 15)
  (setq p 16)
  (setq q 17)
  (setq r 18)
  (setq s 19)
  (setq t 20)
  (setq u 21)
  (setq v 22)
  (setq w 23)
  (setq x 24)
  (setq y 25)
  (setq z 26)
)
(defun test2 ()
  (setq a 1 
        b 2 
        c 3 
        d 4 
        e 5 
        f 6 
        g 7 
        h 8 
        i 9 
        j 10 
        k 11 
        l 12 
        m 13 
        n 14 
        o 15 
        p 16 
        q 17 
        r 18 
        s 19 
        t 20 
        u 21 
        v 22 
        w 23 
        x 24 
        y 25 
        z 26)
)
;--------1---------2---------3---------4---------5---------6---------7
;
;  Listing 3  Test functions for entity handling functions
;
;--------1---------2---------3---------4---------5---------6---------7
;
(defun test3 ()
   (setq lyr "0"
         lcnt 0 acnt 0 ccnt 0 pcnt 0 bcnt 0 xtot 0.0
         en (entnext))
   (while en
     (if (= (cdr (assoc 8 (entget en))) LYR)
         (cond
            ((= "LINE" (cdr (assoc 0 (entget en))))
                 (setq lcnt (1+ lcnt)
                       xtot (+ xtot (cadr (assoc 10 (entget en))))))
            ((= "ARC" (cdr (assoc 0 (entget en))))
                 (setq acnt (1+ acnt)
                       xtot (+ xtot (cadr (assoc 10 (entget en))))))
            ((= "POLYLINE" (cdr (assoc 0 (entget en)))) (setq pcnt (1+ pcnt)))
            ((= "CIRCLE" (cdr (assoc 0 (entget en))))
                 (setq ccnt (1+ ccnt)
                       xtot (+ xtot (cadr (assoc 10 (entget en))))))
            ((= "INSERT" (cdr (assoc 0 (entget en))))
                 (setq bcnt (1+ bcnt)
                       xtot (+ xtot (cadr (assoc 10 (entget en))))))
            )
      )
      (setq en (entnext en))
   )
)
(defun test4 ()
   (setq lyr "0"
         lcnt 0 acnt 0 ccnt 0 pcnt 0 bcnt 0 xtot 0.0
         en (entnext))
   (while en
     (setq el (entget en))
     (if (= (cdr (assoc 8 el)) LYR)
         (cond
            ((= "LINE" (cdr (assoc 0 el)))
                 (setq lcnt (1+ lcnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "ARC" (cdr (assoc 0 el)))
                 (setq acnt (1+ acnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "POLYLINE" (cdr (assoc 0 el))) (setq pcnt (1+ pcnt)))
            ((= "CIRCLE" (cdr (assoc 0 el)))
                 (setq ccnt (1+ ccnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "INSERT" (cdr (assoc 0 el)))
                 (setq bcnt (1+ bcnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            )
      )
      (setq en (entnext en))
   )
)
(defun test5 ()
   (setq lyr "0"
         lcnt 0 acnt 0 ccnt 0 pcnt 0 bcnt 0 xtot 0.0
         en (entnext))
   (while en
     (setq el (entget en) etyp (cdr (assoc 0 el)))
     (if (= (cdr (assoc 8 el)) LYR)
         (cond
            ((= "LINE" etyp)
                 (setq lcnt (1+ lcnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "ARC" etyp)
                 (setq acnt (1+ acnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "POLYLINE" etyp) (setq pcnt (1+ pcnt)))
            ((= "CIRCLE" etyp)
                 (setq ccnt (1+ ccnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            ((= "INSERT" etyp)
                 (setq bcnt (1+ bcnt)
                       xtot (+ xtot (cadr (assoc 10 el)))))
            )
      )
      (setq en (entnext en))
   )
)
