; compline.lsp   16:41:57  1/11/1987

(DeFun C:CL ()
   (SgnOn)
   (SetQ BlipSave (GetVar "blipmode"))
   (SetQ CmdSave (GetVar "cmdecho"))
   (SetQ HiSave (GetVar "highlight"))
   (SetQ OSSave (GetVar "osmode"))
   (SetVar "blipmode" 0)
   (SetVar "cmdecho" 1)
   (SetVar "highlight" 0)
   (SetVar "osmode" 0)
   (If (/= OSSave 0)
      (ProgN
         (PrintEm (List "\nOSNAP set to NONE... Use OSNAP subcommands (end, mid, etc.) when picking.\n"
                        "Please acknowledge by pressing RETURN\n"))
         (GetString)))
   (If (>= Version 2.0)
      (BlockHead))
   (GraphScr)
   (SetQ RtoD (/ 180.0 pi))
   (SetQ Start (GetPoint "Pick starting point of line "))
   (SetQ L1 Start)
   (TerPri)
   (SetQ *Error* DEnd)
   (While T
      (If (Eq BlockIt T)                    ; initialize selection set
         (SetQ BlockSS (SSAdd)))
      (GraphScr)
      (If (>= Version 2.0)
         (SetQ LL (GetPoint L1 "Pick end point of line "))
         (SetQ LL (GetPoint "Pick end point of line ")))
      (If (Null LL)
         (exit)
         (SetQ L2 LL))
      (CompLine)
      (If (Eq BlockIt T)
         (TurnIntoOne))))

(DeFun TurnIntoOne ( / C)
   (SetQ BlockName (StrCat BlockPrefix (ItoA BlockNum)))
   (Command "block" BlockName L1 BlockSS "")
   (Command "insert" BlockName L1 1 1 0)
   (SetQ BlockNum (1+ BlockNum))
   (If (> BlockNum 9999)
      (ProgN
         (PrintEm (List "\nBlock number = 9999 (can't go any higher)\n"
                        "Pick a new block name\n"))
         (SetQ BlockPrefix
            (StrCat
               (SubStr BlockPrefix 1
                  (1- (SetQ C (StrLen BlockPrefix))))
               (Chr (1+ (Ascii (SubStr BlockPrefix C))))))
          (SetQ BlockNum 1)
          (BlockHead))))

(DeFun BlockHead ()
   (SetQ BlockIt (AskYN "Do you want composite lines to be made into a block" T))
   (If (Eq BlockIt T)
      (ProgN
      (SetQ Frst T)
         (SetQ BP "")
         (While (Or (Eq Frst T)
                    (> (StrLen BP) 27))
            (SetQ Frst ())
            (PrintEm (List
               "Blocks names consist of a prefix, followed by a number.\n"
               "Horrible things will happen if the block name already exists.\n"
               "CompLine has no way of checking to see if the block name has been used.\n"
               "So we leave this up to you; pick a unique block name!\n"
               "What prefix do you want (up to 27 numbers and/or letters are OK)?\n"
               "<" BlockPrefix "> "))
               (SetQ BP (GetString))
            (TerPri))
         (If (Not (Eq BP ""))
            (SetQ BlockPrefix BP))
         (SetQ Frst T)
         (SetQ BN 0)
         (While (Or (Eq Frst T)
                    (< BN 1)
                    (> BN 9999))
            (SetQ Frst ())
            (PrintEm (List "Block numbers may be from 1 to 9999\n"
               "Starting block number? <" BlockNum "> "))
            (SetQ BN (GetInt))
            (If (Eq BN ())
               (SetQ BN BlockNum))
            (TerPri))
         (If (> BN 0)
            (SetQ BlockNum BN))
         (PrintEm (List "Next composite line block will be named:\n"
                        BlockPrefix BlockNum "\n")))))

(DeFun CompLine ()
   (SetQ A (Angle L1 L2))                   ; Angle betwen endpoints (radians)
   (SetQ AP (+ A Piby2))                    ; A plus pi/2 radians
   (SetQ AM (- A Piby2))                    ; A minus pi/2 radians
   (SetQ DA (* A RtoD))                     ; A expressed in degrees
   (If (< DA 0.0)
      (SetQ DA (+ DA 360.0)))
  (If (And (> DA 90.0) (<= DA 270.0))
      (ProgN
         (SetQ AS AP)
         (SetQ AP AM)
         (SetQ AM AS)))
   (SetQ TA (TextOrient DA))
   (Cond
      ((<= (Distance L1 L2) (* Minline 2.0))
         (Command "line" L1 L2 "")
         (If (Eq BlockIt T)
            (SetQ BlockSS (SSAdd (EntLast) BlockSS))))
      (T
         (SetQ LP (Polar L1 A MinLine))
         (Command "line" L1 LP "")
         (If (Eq BlockIt T)
            (SetQ BlockSS (SSAdd (EntLast) BlockSS)))
         (While (> (Distance LP L2) MinLine)
            (ForEach CLI CLD
               (SetQ NI (Nth 1 CLI))        ; Get New Instruction
               (Cond
                  ((Eq "text" NI)
                     (SetQ DL (/ (* (StrLen (Nth 6 CLI)) (Nth 4 CLI) 1.1) 2.0))
                     (SetQ O (/ (Nth 4 CLI) 2.0))
                     (SetQ NP (Polar LP A (* DL 2.0)))
                     (SetQ IP (Polar (Polar LP A DL) AM O)))
                  ((Eq "line" NI)
                     (SetQ NP (Polar LP A Dsh))
                     (SetQ DL 0))
                  ((Eq "id" NI)             ; whitespace
                     (SetQ NP (Polar LP A Dsh))
                     (SetQ DL 0))
                  ((Eq "insert" NI)
                     (SetQ DL (* 1.1 (Nth 4 CLI)))
                     (SetQ NP (Polar LP A DL))
                     (SetQ IP (Polar LP A (/ DL 2.0)))))
               (If (Not (Null Test))
                  (ProgN
                     (PrintEm (List "Distance test: "
                                     (< (Distance NP L2) MinLine) "\n"))
                     (PrintEm (List "A = " A " (Angle NP L2) = " (Angle NP L2)
                                     "  Angle test: "
                                     (< 0.001 (abs (- A (Angle NP L2)))) "\n"))
                     (GetString "<CR> to continue\n")))
               (If (Or (< (Distance NP L2) MinLine)
                       (< 0.001 (Abs (- A (Angle NP L2)))))
                  (ProgN
                     (Command "line" LP L2 "")
                     (SetQ LP L2))
                  (ProgN
                     (SetQ LP (Polar LP A DL))
                     (Eval CLI)
                     (Cond
                        ((Eq "insert" NI)
                           (SetQ DL 0))
                        ((Eq "id" NI)
                           (SetQ DL Dsh))
                        ((Eq "line" NI)
                           (SetQ DL Dsh)))
                     (SetQ LP (Polar LP A DL))))
               (If (Eq BlockIt T)
                  (SetQ BlockSS (SSAdd (EntLast) BlockSS)))))
         (Command "line" LP L2 "")
         (If (Eq BlockIt T)
            (SetQ BlockSS (SSAdd (EntLast) BlockSS)))))
   (SetQ L1 L2))

(DeFun TextOrient (TA)                      ; Orient for bottom or right reading text
   (If (< TA 0.0) (SetQ TA (+ 360.0 TA)))   ; AutoLISP Version 1.0 fixup
   (Cond
      ((<= TA 90.0)                         ; no change
         (SetQ TA TA))
      ((<= TA 270.0)                        ; turn upside down
         (SetQ TA (- TA 180.0)))
      (T                                    ; no change
         (SetQ TA TA))))

(DeFun DEnd (St)
   (If (Not (Or (Eq St "bad point argument")
                (Eq St "quit / exit abort")
                (Eq St "console break")
                (Eq St "bad point value")
                (Eq St "Function cancelled")))
      (PrintEm (List "\n" St ". COMPLINE aborts.\n"))
      (ProgN
         (SetQ *Error* ())
         (Command)
         (If (Not (Eq Start Next))
            (ProgN
               (If (AskYN "Do you wish to close the polygon" ())
                  (ProgN
                     (SetQ L2 Start)
                     (CompLine)
                     (If (Eq BlockIt T)
                        (TurnIntoOne))))))))
   (SetVar "blipmode" BlipSave)
   (SetVar "cmdecho" CmdSave)
   (SetVar "highlight" HiSave)
   (If (/= OSSave 0)
      (ProgN
         (Princ "\nOSNAP restored to previous setting")
         (SetVar "osmode" OSSave)))
   (Princ "\n\nAll done...\n")
   (PrintEm (List "Type CDEF to define new composite line\n"))
   (PrintEm (List "Type CL to use existing composite line...         "))
   ())

(DeFun Real1Get (Prmpt V / X)
   (PrintEm (List "\n" Prmpt " <" V ">: "))
   (SetQ X (GetReal))         ; Get number from user
   (If (Not (Null X))         ; Space or Return?
      (SetQ V X)              ; Value was typed so return it
      (SetQ V V)))            ; Not typed so return default

(DeFun PrintEm (Args / A)
   (ForEach A Args
      (Princ A)))

(DeFun AskYN (Prmpt YN / Strng)
   (PrintEm (List "\n" Prmpt "? <"))
   (If (Not (Null YN))
      (ProgN
         (Princ "Yes")
         (SetQ YN T))
      (ProgN
         (Princ "No")
         (SetQ YN ())))
   (PrintEm (List ">: "))
   (SetQ Strng (GetString))
   (If (Or
          (Eq "Y" (SubStr Strng 1 1))
          (Eq "y" (SubStr Strng 1 1)))
          (SetQ YN T))
   (If (Or (Eq "N" (SubStr Strng 1 1))
           (Eq "n" (SubStr Strng 1 1)))
          (SetQ YN ()))
   (SetQ YN YN))
(DeFun C:CDEF ()
   (PrintEm (List "\nDefine composite line:"))
   (SetQ MinLine (Real1Get "Minimum length of end line segment?" MinLine))
   (SetQ CLD ())
   (Princ "\nJust type one letter followed by RETURN to respond to the next prompt\n")
   (Princ "For example, type T<RETURN> to insert text\n")
   (SetQ Dun ())
   (While (Null Dun)
      (SetQ X
         (ProgN
             (Princ "Block, Line, Text, Whitespace or X to end: ")
             (SubStr (Read-Line) 1 1)))
      (Cond
         ((Or (Eq X "t")(Eq X "T"))
            (SetQ TS
               (ProgN
                  (Princ  "Text string? ")
                  (Read-Line)))
            (SetQ Ht (Real1Get "Text height? " Ht))
            (SetQ X (List 'Command "text" "c" 'IP Ht 'TA TS)))
         ((Or (Eq X "b")(Eq X "B"))
            (SetQ BN (GetString "Block Name? "))
            (SetQ Sx (Real1Get "X Scale factor? " 1.0))
            (SetQ Sy (Real1Get "Y Scale factor? " 1.0))
            (SetQ X (List 'Command "insert" BN 'IP Sx Sy 'DA)))
         ((Or (Eq X "l")(Eq X "L"))
            (SetQ Dsh (Real1Get "Line Segment Length? " Dsh))
            (SetQ X (List 'Command "line" 'LP '(Polar LP A Dsh) "")))
         ((Or (Eq X "p")(Eq X "P"))
            (PlineDef))
         ((Or (Eq X "w")(Eq X "W"))
            (SetQ Dsh (Real1Get "Whitespace Segment Length? " Dsh))
            (SetQ X (List 'Command "id" '(Polar LP A Dsh))))
         ((Or (Eq X "m")(Eq X "M"))
            (SetQ MinLine (Real1Get "Minimum Line Length? " MinLine)))
         ((Or (Eq X "X")(Eq X "x"))
            (SetQ Dun T))
         (T
            (SetQ X "")
            (Princ "\nInvalid option\n")))
      (If (And (Null Dun) (Not (Eq X "")))
         (SetQ CLD (Cons X CLD))))
   (SetQ CLD (Reverse CLD))
   (C:CL))

(DeFun Startup ()
   (SetQ Test ())
   (SetQ Version (atof (substr (Princ (ver)) 18)))
   (terpri)
   (SetQ MinLine 0.5)
   (SetQ Dsh (* MinLine 2.0))
   (SetQ Ht 0.2)
   (SgnOn)
   (SetQ Piby2 (/ pi 2.0))
   (SetQ BlockPrefix "COMPBLOCK")
   (SetQ BlockNum 1)
   (SetQ BlockName (StrCat BlockPrefix (ItoA BlockNum)))
   (SetQ CLD (List (List 'Command "text" "c" 'LP 0.1 'DA "MS")
                   (List 'Command "line" 'LP '(Polar LP A Dsh) "")))
   (C:CDEF)
   ()
)

(DeFun SgnOn ()
   (Printem (List "\n\nComposite line drawing routine V1.3"
                  "   (C) Copyright 1986, 1987 Michael Slinn\n\n")))

(Startup)
