; =========================================================
;  Preliminary set up commands, should be first two in your
;  ACAD.LSP file or the first LSP file loaded.
;
   (setvar "CMDECHO" 0)
   (setq VVV 'atomlist)
   (vmon)
;
;--------1---------2---------3---------4---------5---------6
;   AutoLISP Concepts        September 1987    Listing 1. 
;   Bill Kramer              Kramer Consulting, Inc.
;   
;     C:ED    Editor utility.
;             Invokes the text editor from within the
;             AutoCAD External Command System (PGP).
;             The file name is passed on the command line
;             for editors such as EDLIN, WordStar, ...
;             The LSP extension is automatically added.
;             The file is (LOAD)ed into AutoLISP after the
;             edit session completes.
;--------1---------2---------3---------4---------5---------6
(defun C:ED ()
   (if (null EFnam) (setq EFnam ""))
   (setq S (getstring (strcat "\nFile to edit <" EFnam ">:")))
   (if (/= S "") (setq EFnam S))
   (command "EDIT" (strcat EFnam ".LSP"))
   (prompt (strcat "\nLoading " EFnam "..."))  
   (load EFnam))
;--------1---------2---------3---------4---------5---------6
;   AutoLISP Concepts        September 1987    Listing 2. 
;   Bill Kramer              Kramer Consulting, Inc.
;
;     C:LHS     List heap status report.
;
;     Reports the status of items on the heap.
;
;--------1---------2---------3---------4---------5---------6
(defun C:LHS ()
  (textscr)
  (setq II 0)
  (while (/= (nth II (eval VVV)) 'VVV)
     (setq TT (nth II (eval VVV))
           II (1+ II)
           Ty (type (eval TT)))
     (cond
       ((null Ty) (print TT) (princ " nil"))
       ((= Ty 'SUBR))
       ((= Ty 'LIST)
          (print TT) (princ " <LIST> ")
          (cond
            ((= (type (car (eval TT))) 'PAGETB)
                (princ "Paged function: ")
                (if (> (length (cdr (eval TT))) 1)
                  (princ "on heap")
                  (princ "paged")))
            (t
              (princ "On heap."))))
       ((= Ty 'INT)
          (print TT) (prompt "Integer: ") (princ (eval TT)))
       ((= Ty 'REAL)
          (print TT) (prompt "Real: ") (princ (eval TT)))
       ((= Ty 'SYM)
          (print TT) (prompt "Symbol"))
       ((= Ty 'ENAME)
          (print TT) (prompt "Entity name"))
       ((= Ty 'PICKSET)
          (print TT) (prompt "Selection set"))
       ((= Ty 'FILE)
          (print TT) (prompt "File pointer"))
       ((= Ty 'STR)
          (print TT) (prompt "String: ") (princ (eval TT)))
       (t
          (print TT)
          (princ Ty)))
   )
(print) (setq S "All done")
)
