;  Convert angle in degrees to radians
(defun dtr (a)
   (* pi (/ a 180.0))
)

; Acquire information for garden path

(defun GPUSER ()
   (setq sp (getpoint "\nStart point of path: " ))
   (setq ep (getpoint "\nEnd point of path: " ))
   (setq hwidth (getdist "\nHalf width of path: " sp))
   (setq trad (getdist "\nRadius of tiles: " sp))
   (setq tspac (getdist "\nSpacing between tiles: " sp))

   (setq pangle (angle sp ep))
   (setq plength (distance sp ep))
   (setq width (* 2 hwidth))
   (setq angp90 (+ pangle (dtr 90)))    ;Path angle + 90 deg
   (setq angm90 (- pangle (dtr 90)))    ;Path angle - 90 deg
)

;  Draw outline of path

(defun DRAWOUT ()
   (command "PLINE"
   (setq p (polar sp angm90 hwidth))
   (setq p (polar p pangle plength))
   (setq p (polar p angp90 width))
   (polar p (+ pangle (dtr 180)) plength)
   "CLOSE"
   )
)

;   Place one row of tiles given distance along path
;   and possibly offset it

(defun DROW (pd offset)
   (setq pfirst (polar sp pangle pd))
   (setq pctile (polar pfirst angp90 offset))
   (setq p1tile pctile)
   (while (< (distance pfirst p1tile) (- hwidth trad))
      (command "CIRCLE" p1tile trad)
      (setq p1tile (polar p1tile angp90 (+ tspac trad trad)))
   )
   (setq p1tile (polar pctile angm90 (+ tspac trad trad)))
   (while (< (distance pfirst p1tile) (- hwidth trad))
      (command "CIRCLE" p1tile trad)
      (setq p1tile (polar p1tile angm90 (+ tspac trad trad)))
   )
)

;   Draw the rows of tiles

(defun DRAWTILES ()
   (setq pdist (+ trad tspac))
   (setq off 0.0)
   (while (<= pdist (- plength trad))
      (drow pdist off)
      (setq pdist (+ pdist (* (+ tspac trad trad) (sin (dtr 60)))))
      (if (= off 0.0)
         (setq off (* (+ tspac trad trad) (cos (dtr 60))))
         (setq off 0.0)
      )
   )
)

; execute command, calling constituent fuctions

(defun C:PATH ()
     (gpuser)
     (setq sblip (getvar "blipmode"))
     (setq scmde (getvar "cmdecho"))
     (setvar "blipmode" 0)
     (setvar "cmdecho" 0)
     (drawout)
     (drawtiles)
     (setvar "blipmode" sblip)
     (setvar "cmdecho" scmde)
)