; HATCHLST.LSP
; Hatch entities on specified layers
; Created on 5-23-87
; Written by T. Lloyd Benson
; Republic Research, Inc

(DEFUN C:HATCHLST ()

;######################## INITIALIZE

   (SETQ oldecho (GETVAR "cmdecho"))
   (SETVAR "cmdecho" 0)

;######################## GET USER PARAMETERS

   (SETQ target_layer (GETSTRING "Name of layer for hatching: " ))
   (SETQ hpattern (GETSTRING "Name of hatch pattern to use <ANSI31>: " ))
   (IF (= hpattern "") (SETQ hpattern "ANSI31"))  ; default hatch pattern
   (SETQ h_scale (GETSTRING "Enter scale of hatch pattern <25>: " ))
   (IF (= h_scale  "") (SETQ h_scale "25"))        ; default hatch scale

   (SETQ h_angle (GETSTRING "Enter angle of hatch pattern <0>: " ))
   (IF (= h_angle "") (SETQ h_angle "0"))         ; default hatch angle
   (SETQ f (OPEN (GETSTRING "Enter name of county list file: ") "r"))
   (IF f (PROGN                                   ; IF list file found...

   (COMMAND "LAYER" "make" target_layer "")
   (COMMAND "LAYER" "freeze" "*" "thaw" "ms*,in*" "")

;####################### STEP THROUGH AND HATCH LAYERS LISTED IN FILE

   (SETQ current_cty "0")

   (while (setq current_cty (read-line F))        ; While still layers on file,
      (PRINC (STRCAT "\nScanning for " current_cty))
      (SETQ hatchcty (SSGET "X" (LIST (CONS '8 current_cty))))
      (IF hatchcty
         (command "hatch" hpattern h_scale h_angle hatchcty "")
         (PRINC (STRCAT current_cty " Not found.\n"))
      )
   )                                              ; and do the while loop again.

   (close f)                                      ; Finally, close the list file
   (command "layer" "freeze" "*" "thaw" "ms*,in*" "thaw" target_layer "")
   )                                              ; Close file PROGN

   (PRINC "\nInput list file not found.\n")       ; Else, file not found
   )

;######################### EXIT PROGRAM

   (SETVAR "cmdecho" oldecho)                     ; Reset cmd echo to old value

   (PRINC "\nEnd of procedure.\n")
   (PRINC)
)


