

(if (= C:INSTKEY nil)(load INSTKEY))
INSTKEY
F2 ZOOM A
INSTKEY
F3 ZOOM .5X
INSTKEY
F4 ZOOM 2X
INSTKEY
F5 CATALOG \ACAD\DWG\*.DWG
INSTKEY
F6 CATALOG \ACAD\BLOCK\*.DWG
INSTKEY
F7 CENT
INSTKEY
F8 MID
INSTKEY
F9 ENDP
INSTKEY
F10 INSTKEY R
INSTKEY L



;The name INSTKEY was chosen because it is short for INSTant KEY assignment.
;This AutoLISP routine allows function keys F2 through F10 to be reassigned.
;The CONFIG.SYS file on your system must include the line DEVICE=ANSI.SYS in
;order to use these Escape sequences. Note: It is important to type the
; \e[... strings exactly as listed.
;
(defun reset ()
   (princ "\e[0;60;0;60p") (princ "\e[0;61;0;61p") (princ "\e[0;62;0;62p")
   (princ "\e[0;63;0;63p") (princ "\e[0;64;0;64p") (princ "\e[0;65;0;65p")
   (princ "\e[0;66;0;66p") (princ "\e[0;67;0;67p") (princ "\e[0;68;0;68p")
 ; This series of (princ "....") statements resets keys F2 thru F10
 ; back to the startup values.
   (setq f2n nil f3n nil f4n nil f5n nil f6n nil f7n nil f8n nil
     f9n nil f10n nil)
   (prompt "\n function keys Cleared and RESET.  ") (princ)
 ; This series of setq ... nil resets the AutoLISP values equivalent to
 ; the cleared and reset ANSI.SYS values.

 )
 (defun listit ()
    (prompt "\n This LISTING is valid only during the work session in ")
    (prompt "\n which Function Key assignments were made.  When you start ")
    (prompt "\n your next drawing, this listing says that the function keys ")
    (prompt "\n are not assigned...BUT, they are assigned at the DOS level ")
    (prompt "\n and still have the VALUES assigned previously.  You may use ")
    (prompt "\n RESET function of the INSTKEY command to CLEAR all values. ")
    (prompt "\n..........................................................")
    (prompt "\nCURRENT FUNCTION KEY SETTINGS ARE:  ")
    (if (= f2n nil)(princ "\nF2 key is not assigned.")
(princ (strcat "\nF2 key is " f2n "."))  )
    (if (= f3n nil)(princ "\nF3 key is not assigned.")
(princ (strcat "\nF3 key is " f3n "."))  )
    (if (= f4n nil)(princ "\nF4 key is not assigned.")
(princ (strcat "\nF4 key is " f4n "."))  )
    (if (= f5n nil)(princ "\nF5 key is not assigned.")
(princ (strcat "\nF5 key is " f5n "."))  )
    (if (= f6n nil)(princ "\nF6 key is assigned COORDS.")
(princ (strcat "\nF6 key is " f6n "."))  )
    (if (= f7n nil)(princ "\nF7 key is assigned GRID.")
(princ (strcat "\nF7 key is " f7n "."))  )
    (if (= f8n nil)(princ "\nF8 key is assigned ORTHO.")
(princ (strcat "\nF8 key is " f8n "."))  )
    (if (= f9n nil)(princ "\nF9 key is assigned SNAP.")
(princ (strcat "\nF9 key is " f9n "."))  )
    (if (= f10n nil)(princ "\nF10 key is assigned TABLET.    ")
(princ (strcat "\nF10 key is " f10n ".    ")))
    (princ)
 )
 (defun nameit ()
    (princ (strcat "\nWhat Function or Command to give to " key))
    (setq strg (getstring T " key? "));the T allows embedded spaces
       (if (= key "F2")(progn (princ (strcat f2k qt strg qt cr))
    (setq f2n strg) ))
       (if (= key "F3")(progn (princ (strcat f3k qt strg qt cr))
    (setq f3n strg) ))
       (if (= key "F4")(progn (princ (strcat f4k qt strg qt cr ))
      (setq f4n strg) ))
       (if (= key "F5")(progn (princ (strcat f5k qt strg qt cr ))
      (setq f5n strg) ))
       (if (= key "F6")(progn (princ (strcat f6k qt strg qt cr ))


      (setq f6n strg) ))
       (if (= key "F7")(progn (princ (strcat f7k qt strg qt cr ))
      (setq f7n strg) ))
       (if (= key "F8")(progn (princ (strcat f8k qt strg qt cr ))
      (setq f8n strg) ))
       (if (= key "F9")(progn (princ (strcat f9k qt strg qt cr ))
      (setq f9n strg) ))
       (if (= key "F10")(progn (princ (strcat f10k qt strg qt cr ))
      (setq f10n strg) ))
       (princ)
 )


(defun C:INSTKEY ()
   (textscr) (setq qt "\042" cr ";13p")  ;assigns quote & carriage return
   (setq f2k "\e[0;60;" f3k "\e[0;61;" f4k "\e[0;62;" f5k "\e[0;63;"
 f6k "\e[0;64;" f7k "\e[0;65;" f8k "\e[0;66;" f9k "\e[0;67;"
 f10k "\e[0;68;" ) ;assigns escape code for F2 through F10
 ;Note: Character values given in the "\nnn" form have Octal notation,
 ;character values given in the "nnn;nnn;" form are Decimal notation.
    (initget 1 "F2 F3 F4 F5 F6 F7 F8 F9 F10 L R")
       (prompt "\nWhich function key to redefine? <F2 thru F10>: ")
       (prompt "\nOr enter <L> for Listing of current key settings: ")
    (setq key (getkword "\nOr enter <R> to RESET and Clear all values:  "))
    (terpri) (princ key) (princ)
(if (= key "R") (reset))  ;calls reset function
(if (= key "L") (listit)) ;calls listing function
(if (/= key "R")(if (/= key "L")(nameit))) ; calls naming function
)




;This AutoLISP routine creates a DOS Batch File
;that can be run from the DOS prompt after you exit AutoCAD.
;It is to be used to CLEAR and RESET the F2 through F10 keys.
;
(defun C:RESETBAT (/ f ec )
   (setq f (open "RESET.BAT" "w"))
   (setq ec "ECHO ")
     (write-line "@ECHO OFF" f)
     (write-line (strcat ec "\e[0;60;0;60p") f)
     (write-line (strcat ec "\e[0;61;0;61p") f)
     (write-line (strcat ec "\e[0;62;0;62p") f)
     (write-line (strcat ec "\e[0;63;0;63p") f)
     (write-line (strcat ec "\e[0;64;0;64p") f)
     (write-line (strcat ec "\e[0;65;0;65p") f)
     (write-line (strcat ec "\e[0;66;0;66p") f)
     (write-line (strcat ec "\e[0;67;0;67p") f)
     (write-line (strcat ec "\e[0;68;0;68p") f)

     (write-line "ECHO F2 thru F10 Cleared and Reset." f)
   (prompt "\nRESET batch file is now on your current drive.     ")
   (princ)
   (close f )
)
