; -------1---------2---------3---------4---------5---------6---------7
;
;   Advanced AutoLISP Concepts         January 1989 <Happy New Year!>
;   Bill Kramer, Kramer Consulting, Inc.
;
;   Listing 1
;
(defun C:ED ( / Temp)
  (if (or (null LSPFIL)  ; LSPFIL initialized?
          (not (equal (type LSPFIL) 'STR))) ; is it a string?
            (setq LSPFIL "ACAD")) ; if either, initialize it.
  (setq Temp
    (strcase  ; Convert to upper case.
     (getstring 
       (strcat "\nFile name to edit <" LSPFIL ">:")))) 
  (if (/= Temp "") 
      (setq LSPFIL Temp))
  (setq Temp
    (findfile  ; Locate the complete file name.
       (strcat LSPFIL ".LSP")))
  (command "EDIT" Temp)  ; Use ACAD.PGP Edit command.
  ; PGP Entry example   EDIT,MYEDITOR,138000,File to edit:,0
  (prompt (strcat "\nLoading " Temp "\n"))
  (setq Temp (load Temp "Invalid File"))
  (princ Temp)
  (princ)
)
; -------1---------2---------3---------4---------5---------6---------7
;
;  Listing 2
;
;  FPRINT   formatted print of symbol / function to file.
;
;  example:  (fprint fprint fh 0)
;
;            prints listing of FPRINT macro to file of
;            operator's choice.
;
(defun fprint (symbol fh lvl)
   (if (null fh)
      (setq FH (getstring "\nFile name for output:")
            Lvl 0
            FH (open FH "w")))
   (cond
      ((atom symbol) (princ " " FH) (prin1 symbol FH))
      (t 
         (princ "\n" FH)
         (repeat (* 2 lvl) (princ " " FH))
         (princ "(" FH)
         (foreach symb symbol
            (fprint symb fh (1+ lvl)))
         (princ ")" FH) (princ "\n" FH)
         (if (> lvl 0) (repeat (* 2 (1- lvl)) (princ " " FH)))
      ))
   (if (= lvl 0) (setq FH (close FH)))
   (princ)
)
; -------1---------2---------3---------4---------5---------6---------7
;
;   Listing 3
;
;   Math function library additions
;
;    ARC-Cosine  ACOS(real_number.sine)
;    ARC-Sine    ASIN(real_number.sine)
;
;    Functions both return angle values in radians.
;
(defun acos (cs)
   (cond
     ((> (abs cs) 1.0) (prompt " Arc-cosine error."))
     ((equal cs 1.0 0.000000001)
          0.0) 
     ((equal cs -1.0 0.000000001)
          pi)
     (t
          (-
            (/ pi 2)
            (atan (/ cs (sqrt (- 1 (* cs cs))))))))) 
;
(defun asin (sn)
   (cond
     ((> (abs sn) 1.0) (prompt " Arc-sine error."))
     ((equal (abs sn) 1.0 0.000000001)
        (* sn (/ pi 2)))
     ((zerop sn)
        0.0)
     (t
        (atan (/ sn (sqrt (- 1 (* sn sn))))))))
;
; -------1---------2---------3---------4---------5---------6---------7
;
 Line Nest
   1   0     ;   Listing 4
   2   0     ;
   3   0     ;   Example output from nesting report
   4   0     ;   Nest is number of open parens at beginning of line. 
   5   0     (defun extra_right (A B C X)
   6   1       (setq X
   7   2         (sqrt 
   8   3          (+
   9   4           (* A X X))
  10   3           (* B X) C)))
  11   0       (/ X    
  12   1          (sqrt
  13   2             (+ (* A A) (* B B) (* C C)))))
